#!/usr/bin/perl

if (($na = $#ARGV)<2) {
    print "-----------------------------------------------------------------\n";
    print "Purpose : Merges plyrdata files into single plyrdata file.\n";
    print "Usage : makedata <database> <primary input> <secondary input> ...\n";
    print "\nAuthor : Chris Kaye, June 1998.\n";
    print "-----------------------------------------------------------------\n";
    exit(0);
}

for ($i=1; $i<=600; $i++) {
    $xref[$i] = -1;
}

print "Input files : ";
for ($i=0; $i<=$na; $i++) { 
    print $ARGV[$i], " ";
    $input{$i} = $ARGV[$i];
}
print "\n";
print "Output file : $ARGV[0]\n";
$output = $ARGV[0];

$nb=0;
if (open(IN, $input{0})) {
    print "Processing file ", $input{0}, " ...\n";
header:     while ($line = <IN>) {
        chomp($line);
        last header if ($line =~ /^Number of Areas =,/);
    }

    while ($line = <IN>) {
        $nb = $nb + 1;
        chomp($line);
        $_ = $line;
        ($area[$nb], $owner[$nb], $type[$nb], $sp[$nb], $adj1[$nb], $adj2[$nb], $adj3[$nb], $adj4[$nb], $adj5[$nb], $adj6[$nb], $adj7[$nb], $adj8[$nb], $adj9[$nb], $adj10[$nb], $x1[$nb], $x2[$nb], $x3[$nb], $y1[$nb], $y2[$nb], $y3[$nb], $unit_owner[$nb], $unit[$nb]) = split;
        if ($owner[$nb] < 27) {
            $owner[$nb] = $owner[$nb] + 27;
        }
        if ($unit_owner[$nb] < 27) {
            $unit_owner[$nb] = $unit_owner[$nb] + 27;
        }
        $xref[$area[$nb]] = $nb;
        $from[$nb] = 0;
    }
    close(IN);
}
else {
    print "Skipping file ", $input{0},  "!\n";
}

print "Number of original areas = ", $nb, "\n";

open(OUT, ">".$output) || die "Impossible to open : $output !";
open(IN, $input{1}) || die "Impossible to open : $input{1} !";

print "Processing file ", $input{1}, " ...\n";
mailheader: while ($line = <IN>) {
    chomp($line);
    last mailheader if ($line =~ /^AOD.../);
}
if ($line =~ /^AOD.../) {
    print OUT $line, "\n";
}

if ($line = <IN>) {
    chomp($line);
    ($ids, $dummy) = split(/, /, $line);
    $_ = $ids;
    ($playernumber, $playerid) = split;
    print OUT $line, "\n";
}

relations: while ($line = <IN>) {
    chomp($line);
    if ($line =~ /^Number of Players =,/) {
        ($dummy, $unknown) = split(/, /, $line);
    }
    last relations if ($line =~ /^Number of Areas =,/);
    print OUT $line, "\n";
}

$nd=0;
$nn=0;
$nu=0;
while ($line = <IN>) {
    $nb = $nb + 1;
    chomp($line);
    $_ = $line;
    ($area[$nb], $owner[$nb], $type[$nb], $sp[$nb], $adj1[$nb], $adj2[$nb], $adj3[$nb], $adj4[$nb], $adj5[$nb], $adj6[$nb], $adj7[$nb], $adj8[$nb], $adj9[$nb], $adj10[$nb], $x1[$nb], $x2[$nb], $x3[$nb], $y1[$nb], $y2[$nb], $y3[$nb], $unit_owner[$nb], $unit[$nb]) = split;
    if ($xref[$area[$nb]] == -1) {
        $xref[$area[$nb]] = $nb;
        $nn = $nn + 1;
        $from[$nb] = 1;
    }
    else {
        $found = $xref[$area[$nb]];
        if ($owner[$nb] == $unknown) {
            $nu = $nu + 1;
        }
        else {
            $owner[$found] = $owner[$nb];
            $unit_owner[$found] = $unit_owner[$nb];
            $unit[$found] = $unit[$nb];
            $nd = $nd + 1;
        }
        if ($adj1[$found] == 0) {$adj1[$found] = $adj1[$nb];}
        if ($adj2[$found] == 0) {$adj2[$found] = $adj2[$nb];}
        if ($adj3[$found] == 0) {$adj3[$found] = $adj3[$nb];}
        if ($adj4[$found] == 0) {$adj4[$found] = $adj4[$nb];}
        if ($adj5[$found] == 0) {$adj5[$found] = $adj5[$nb];}
        if ($adj6[$found] == 0) {$adj6[$found] = $adj6[$nb];}
        if ($adj7[$found] == 0) {$adj7[$found] = $adj7[$nb];}
        if ($adj8[$found] == 0) {$adj8[$found] = $adj8[$nb];}
        if ($adj9[$found] == 0) {$adj9[$found] = $adj9[$nb];}
        if ($adj10[$found] == 0) {$adj10[$found] = $adj10[$nb];}
        $nb = $nb - 1;
        $from[$found] = 1;
    }
}
close(IN);
print "Number of new areas = ", $nn, "\n";
print "Number of unknown areas = ", $nu, "\n";
print "Number of updated areas = ", $nd, "\n";

unless ($input{2} =~ /\?\?$/) {
    print "Number of primary areas = ", $nb, "\n";
    for ($i=2; $i<=$na; $i++) {

        open(IN, $input{$i}) || die "Impossible to open : $input{$i} !";

        print "Processing file ", $input{$i}, " ...\n";
        $nd=0;
        $nn=0;
        $nu=0;
        while ($line = <IN>) {
            $nb = $nb + 1;
            chomp($line);
            $_ = $line;
            ($area[$nb], $owner[$nb], $type[$nb], $sp[$nb], $adj1[$nb], $adj2[$nb], $adj3[$nb], $adj4[$nb], $adj5[$nb], $adj6[$nb], $adj7[$nb], $adj8[$nb], $adj9[$nb], $adj10[$nb], $x1[$nb], $x2[$nb], $x3[$nb], $y1[$nb], $y2[$nb], $y3[$nb], $unit_owner[$nb], $unit[$nb]) = split;
            if ($xref[$area[$nb]] == -1) {
                $xref[$area[$nb]] = $nb;
                $nn = $nn + 1;
                $found[$nb] = $i;
            }
            else {
                $found = $xref[$area[$nb]];
                if ($owner[$nb] == $unknown) {
                    $nu = $nu + 1;
                }
                else {
                    $owner[$found] = $owner[$nb];
                    $unit_owner[$found] = $unit_owner[$nb];
                    $unit[$found] = $unit[$nb];
                    $nd = $nd + 1;
                }
                if ($adj1[$found] == 0) {$adj1[$found] = $adj1[$nb];}
                if ($adj2[$found] == 0) {$adj2[$found] = $adj2[$nb];}
                if ($adj3[$found] == 0) {$adj3[$found] = $adj3[$nb];}
                if ($adj4[$found] == 0) {$adj4[$found] = $adj4[$nb];}
                if ($adj5[$found] == 0) {$adj5[$found] = $adj5[$nb];}
                if ($adj6[$found] == 0) {$adj6[$found] = $adj6[$nb];}
                if ($adj7[$found] == 0) {$adj7[$found] = $adj7[$nb];}
                if ($adj8[$found] == 0) {$adj8[$found] = $adj8[$nb];}
                if ($adj9[$found] == 0) {$adj9[$found] = $adj9[$nb];}
                if ($adj10[$found] == 0) {$adj10[$found] = $adj10[$nb];}
                $nb = $nb - 1;
                $from[$found] = $i;
            }
        }
        close(IN);
        print "Number of new areas = ", $nn, "\n";
        print "Number of unknown areas = ", $nu, "\n";
        print "Number of updated areas = ", $nd, "\n";

    }
}

print "Total number of areas = ", $nb, "\n";
print OUT "Number of Areas =, ", $nb, "\n";

for ($j=1; $j<=600; $j++) {
    $i = $xref[$j];
    if ($owner[$i] == $playernumber ) {
        print OUT $area[$i]," ", $owner[$i]," ", $type[$i]," ", $sp[$i]," ", $adj1[$i]," ", $adj2[$i]," ", $adj3[$i]," ", $adj4[$i]," ", $adj5[$i]," ", $adj6[$i]," ", $adj7[$i]," ", $adj8[$i]," ", $adj9[$i]," ", $adj10[$i]," ", $x1[$i]," ", $x2[$i]," ", $x3[$i]," ", $y1[$i]," ", $y2[$i]," ", $y3[$i]," ", $unit_owner[$i]," ", $unit[$i],"\n";
    };
}

for ($j=1; $j<=600; $j++) {
    $i = $xref[$j];
    if ($i != -1) {
        if (($owner[$i] != $playernumber ) && ($from[$i] == 1)) {
            print OUT $area[$i]," ", $owner[$i]," ", $type[$i]," ", $sp[$i]," ", $adj1[$i]," ", $adj2[$i]," ", $adj3[$i]," ", $adj4[$i]," ", $adj5[$i]," ", $adj6[$i]," ", $adj7[$i]," ", $adj8[$i]," ", $adj9[$i]," ", $adj10[$i]," ", $x1[$i]," ", $x2[$i]," ", $x3[$i]," ", $y1[$i]," ", $y2[$i]," ", $y3[$i]," ", $unit_owner[$i]," ", $unit[$i],"\n";
        }
    }
}

for ($j=1; $j<=600; $j++) {
    $i = $xref[$j];
    if ($i != -1) {
        if (($owner[$i] != $playernumber ) && ($from[$i] != 1)) {
            print OUT $area[$i]," ", $owner[$i]," ", $type[$i]," ", $sp[$i]," ", $adj1[$i]," ", $adj2[$i]," ", $adj3[$i]," ", $adj4[$i]," ", $adj5[$i]," ", $adj6[$i]," ", $adj7[$i]," ", $adj8[$i]," ", $adj9[$i]," ", $adj10[$i]," ", $x1[$i]," ", $x2[$i]," ", $x3[$i]," ", $y1[$i]," ", $y2[$i]," ", $y3[$i]," ", $unit_owner[$i]," ", $unit[$i],"\n";
        }
    }
}
close(OUT);

